Index: code/branches/core5/src/modules/gamestates/GSRoot.cc
===================================================================
--- code/branches/core5/src/modules/gamestates/GSRoot.cc	(revision 5829)
+++ code/branches/core5/src/modules/gamestates/GSRoot.cc	(revision 5831)
@@ -103,5 +103,5 @@
         }
 
-        for (ObjectList<TimerBase>::iterator it = ObjectList<TimerBase>::begin(); it; )
+        for (ObjectList<Timer>::iterator it = ObjectList<Timer>::begin(); it; )
             (it++)->tick(time);
 
Index: code/branches/core5/src/modules/overlays/FadeoutText.cc
===================================================================
--- code/branches/core5/src/modules/overlays/FadeoutText.cc	(revision 5829)
+++ code/branches/core5/src/modules/overlays/FadeoutText.cc	(revision 5831)
@@ -46,5 +46,5 @@
 
         this->bFadingOut_ = false;
-        this->fadeouttimer_.setTimer(3.0f, false, this, createExecutor(createFunctor(&FadeoutText::fadeout)));
+        this->fadeouttimer_.setTimer(3.0f, false, createExecutor(createFunctor(&FadeoutText::fadeout, this)));
         this->fadeouttimer_.stopTimer();
 
Index: code/branches/core5/src/modules/overlays/FadeoutText.h
===================================================================
--- code/branches/core5/src/modules/overlays/FadeoutText.h	(revision 5829)
+++ code/branches/core5/src/modules/overlays/FadeoutText.h	(revision 5831)
@@ -68,5 +68,5 @@
 
             bool bFadingOut_;
-            Timer<FadeoutText> fadeouttimer_;
+            Timer fadeouttimer_;
 
             float initialAlpha_;
Index: code/branches/core5/src/modules/overlays/hud/ChatOverlay.cc
===================================================================
--- code/branches/core5/src/modules/overlays/hud/ChatOverlay.cc	(revision 5829)
+++ code/branches/core5/src/modules/overlays/hud/ChatOverlay.cc	(revision 5831)
@@ -87,5 +87,5 @@
         COUT(0) << "Chat: " << text << std::endl;
 
-        new Timer<ChatOverlay>(this->displayTime_, false, this, createExecutor(createFunctor(&ChatOverlay::dropMessage)), true);
+        new Timer(this->displayTime_, false, createExecutor(createFunctor(&ChatOverlay::dropMessage, this)), true);
 
         this->updateOverlayText();
Index: code/branches/core5/src/modules/overlays/hud/UnderAttackHealthBar.cc
===================================================================
--- code/branches/core5/src/modules/overlays/hud/UnderAttackHealthBar.cc	(revision 5829)
+++ code/branches/core5/src/modules/overlays/hud/UnderAttackHealthBar.cc	(revision 5831)
@@ -52,5 +52,5 @@
         this->text_->setPickPoint(Vector2(0.5, 0));
 
-        this->inittimer_.setTimer(0.0f, false, this, createExecutor(createFunctor(&UnderAttackHealthBar::init)));
+        this->inittimer_.setTimer(0.0f, false, createExecutor(createFunctor(&UnderAttackHealthBar::init, this)));
     }
 
Index: code/branches/core5/src/modules/overlays/hud/UnderAttackHealthBar.h
===================================================================
--- code/branches/core5/src/modules/overlays/hud/UnderAttackHealthBar.h	(revision 5829)
+++ code/branches/core5/src/modules/overlays/hud/UnderAttackHealthBar.h	(revision 5831)
@@ -62,5 +62,5 @@
             PlayerInfo* owner_;
             OverlayText* text_;
-            Timer<UnderAttackHealthBar> inittimer_;
+            Timer inittimer_;
     };
 }
Index: code/branches/core5/src/modules/pong/Pong.cc
===================================================================
--- code/branches/core5/src/modules/pong/Pong.cc	(revision 5829)
+++ code/branches/core5/src/modules/pong/Pong.cc	(revision 5831)
@@ -52,5 +52,5 @@
         this->setHUDTemplate("PongHUD");
 
-        this->starttimer_.setTimer(1.0, false, this, createExecutor(createFunctor(&Pong::startBall)));
+        this->starttimer_.setTimer(1.0, false, createExecutor(createFunctor(&Pong::startBall, this)));
         this->starttimer_.stopTimer();
 
Index: code/branches/core5/src/modules/pong/Pong.h
===================================================================
--- code/branches/core5/src/modules/pong/Pong.h	(revision 5829)
+++ code/branches/core5/src/modules/pong/Pong.h	(revision 5831)
@@ -62,5 +62,5 @@
             PongBall* ball_;
             PongBat* bat_[2];
-            Timer<Pong> starttimer_;
+            Timer starttimer_;
     };
 }
Index: code/branches/core5/src/modules/pong/PongAI.cc
===================================================================
--- code/branches/core5/src/modules/pong/PongAI.cc	(revision 5829)
+++ code/branches/core5/src/modules/pong/PongAI.cc	(revision 5831)
@@ -60,5 +60,5 @@
     PongAI::~PongAI()
     {
-        for (std::list<std::pair<Timer<PongAI>*, char> >::iterator it = this->reactionTimers_.begin(); it != this->reactionTimers_.end(); ++it)
+        for (std::list<std::pair<Timer*, char> >::iterator it = this->reactionTimers_.begin(); it != this->reactionTimers_.end(); ++it)
             (*it).first->destroy();
     }
@@ -231,6 +231,6 @@
 
             // Add a new Timer
-            Timer<PongAI>* timer = new Timer<PongAI>(delay, false, this, createExecutor(createFunctor(&PongAI::delayedMove)));
-            this->reactionTimers_.push_back(std::pair<Timer<PongAI>*, char>(timer, direction));
+            Timer* timer = new Timer(delay, false, createExecutor(createFunctor(&PongAI::delayedMove, this)));
+            this->reactionTimers_.push_back(std::pair<Timer*, char>(timer, direction));
         }
         else
@@ -246,5 +246,5 @@
 
         // Destroy the timer and remove it from the list
-        Timer<PongAI>* timer = this->reactionTimers_.front().first;
+        Timer* timer = this->reactionTimers_.front().first;
         timer->destroy();
 
Index: code/branches/core5/src/modules/pong/PongAI.h
===================================================================
--- code/branches/core5/src/modules/pong/PongAI.h	(revision 5829)
+++ code/branches/core5/src/modules/pong/PongAI.h	(revision 5831)
@@ -65,5 +65,5 @@
             float strength_;
 
-            std::list<std::pair<Timer<PongAI>*, char> > reactionTimers_;
+            std::list<std::pair<Timer*, char> > reactionTimers_;
             char movement_;
             char oldMove_;
Index: code/branches/core5/src/modules/weapons/MuzzleFlash.cc
===================================================================
--- code/branches/core5/src/modules/weapons/MuzzleFlash.cc	(revision 5829)
+++ code/branches/core5/src/modules/weapons/MuzzleFlash.cc	(revision 5831)
@@ -42,5 +42,5 @@
         this->setScale(0.1f);
 
-        this->delayTimer_.setTimer(0.1f, false, this, createExecutor(createFunctor(&MuzzleFlash::destroy)));
+        this->delayTimer_.setTimer(0.1f, false, createExecutor(createFunctor(&MuzzleFlash::destroy, this)));
     }
 }
Index: code/branches/core5/src/modules/weapons/MuzzleFlash.h
===================================================================
--- code/branches/core5/src/modules/weapons/MuzzleFlash.h	(revision 5829)
+++ code/branches/core5/src/modules/weapons/MuzzleFlash.h	(revision 5831)
@@ -44,5 +44,5 @@
 
         private:
-            Timer<MuzzleFlash> delayTimer_;
+            Timer delayTimer_;
     };
 }
Index: code/branches/core5/src/modules/weapons/munitions/ReplenishingMunition.cc
===================================================================
--- code/branches/core5/src/modules/weapons/munitions/ReplenishingMunition.cc	(revision 5829)
+++ code/branches/core5/src/modules/weapons/munitions/ReplenishingMunition.cc	(revision 5831)
@@ -44,5 +44,5 @@
         // replenishIntervall_ and replenishMunitionAmount_ will be set in the constructor of the
         // inheriting class, which comes after this constructor)
-        this->replenishingTimer_.setTimer(0.0f, false, this, createExecutor(createFunctor(&ReplenishingMunition::initializeTimer)));
+        this->replenishingTimer_.setTimer(0.0f, false, createExecutor(createFunctor(&ReplenishingMunition::initializeTimer, this)));
     }
 
@@ -50,5 +50,5 @@
     {
         // Initialize the timer
-        this->replenishingTimer_.setTimer(this->replenishIntervall_, true, this, createExecutor(createFunctor(&ReplenishingMunition::replenish)));
+        this->replenishingTimer_.setTimer(this->replenishIntervall_, true, createExecutor(createFunctor(&ReplenishingMunition::replenish, this)));
     }
 
Index: code/branches/core5/src/modules/weapons/munitions/ReplenishingMunition.h
===================================================================
--- code/branches/core5/src/modules/weapons/munitions/ReplenishingMunition.h	(revision 5829)
+++ code/branches/core5/src/modules/weapons/munitions/ReplenishingMunition.h	(revision 5831)
@@ -51,5 +51,5 @@
             void initializeTimer();
 
-            Timer<ReplenishingMunition> replenishingTimer_;
+            Timer replenishingTimer_;
     };
 }
Index: code/branches/core5/src/modules/weapons/projectiles/LightningGunProjectile.cc
===================================================================
--- code/branches/core5/src/modules/weapons/projectiles/LightningGunProjectile.cc	(revision 5829)
+++ code/branches/core5/src/modules/weapons/projectiles/LightningGunProjectile.cc	(revision 5831)
@@ -42,5 +42,5 @@
         this->textureIndex_ = 1;
         this->maxTextureIndex_ = 8;
-        this->textureTimer_.setTimer(0.01f, true, this, createExecutor(createFunctor(&LightningGunProjectile::changeTexture)));
+        this->textureTimer_.setTimer(0.01f, true, createExecutor(createFunctor(&LightningGunProjectile::changeTexture, this)));
         
         registerVariables();
Index: code/branches/core5/src/modules/weapons/projectiles/LightningGunProjectile.h
===================================================================
--- code/branches/core5/src/modules/weapons/projectiles/LightningGunProjectile.h	(revision 5829)
+++ code/branches/core5/src/modules/weapons/projectiles/LightningGunProjectile.h	(revision 5831)
@@ -50,5 +50,5 @@
             unsigned int textureIndex_;
             unsigned int maxTextureIndex_;
-            Timer<LightningGunProjectile> textureTimer_;
+            Timer textureTimer_;
             std::string materialBase_;
       private:
Index: code/branches/core5/src/modules/weapons/projectiles/Projectile.cc
===================================================================
--- code/branches/core5/src/modules/weapons/projectiles/Projectile.cc	(revision 5829)
+++ code/branches/core5/src/modules/weapons/projectiles/Projectile.cc	(revision 5831)
@@ -61,5 +61,5 @@
             this->attachCollisionShape(shape);
 
-            this->destroyTimer_.setTimer(this->lifetime_, false, this, createExecutor(createFunctor(&Projectile::destroyObject)));
+            this->destroyTimer_.setTimer(this->lifetime_, false, createExecutor(createFunctor(&Projectile::destroyObject, this)));
         }
     }
Index: code/branches/core5/src/modules/weapons/projectiles/Projectile.h
===================================================================
--- code/branches/core5/src/modules/weapons/projectiles/Projectile.h	(revision 5829)
+++ code/branches/core5/src/modules/weapons/projectiles/Projectile.h	(revision 5831)
@@ -66,5 +66,5 @@
             float damage_;
             bool bDestroy_;
-            Timer<Projectile> destroyTimer_;
+            Timer destroyTimer_;
     };
 }
Index: code/branches/core5/src/modules/weapons/weaponmodes/EnergyDrink.cc
===================================================================
--- code/branches/core5/src/modules/weapons/weaponmodes/EnergyDrink.cc	(revision 5829)
+++ code/branches/core5/src/modules/weapons/weaponmodes/EnergyDrink.cc	(revision 5831)
@@ -54,5 +54,5 @@
         this->setMunitionName("FusionMunition");
 
-        this->delayTimer_.setTimer(1.0f, false, this, createExecutor(createFunctor(&EnergyDrink::shot)));
+        this->delayTimer_.setTimer(1.0f, false, createExecutor(createFunctor(&EnergyDrink::shot, this)));
         this->delayTimer_.stopTimer();
     }
Index: code/branches/core5/src/modules/weapons/weaponmodes/EnergyDrink.h
===================================================================
--- code/branches/core5/src/modules/weapons/weaponmodes/EnergyDrink.h	(revision 5829)
+++ code/branches/core5/src/modules/weapons/weaponmodes/EnergyDrink.h	(revision 5831)
@@ -59,5 +59,5 @@
             float speed_;
             float delay_;
-            Timer<EnergyDrink> delayTimer_;
+            Timer delayTimer_;
     };
 }
Index: code/branches/core5/src/modules/weapons/weaponmodes/HsW01.cc
===================================================================
--- code/branches/core5/src/modules/weapons/weaponmodes/HsW01.cc	(revision 5829)
+++ code/branches/core5/src/modules/weapons/weaponmodes/HsW01.cc	(revision 5831)
@@ -54,5 +54,5 @@
         this->setMunitionName("LaserMunition");
 
-        this->delayTimer_.setTimer(1.0f, false, this, createExecutor(createFunctor(&HsW01::shot)));
+        this->delayTimer_.setTimer(1.0f, false, createExecutor(createFunctor(&HsW01::shot, this)));
         this->delayTimer_.stopTimer();
     }
Index: code/branches/core5/src/modules/weapons/weaponmodes/HsW01.h
===================================================================
--- code/branches/core5/src/modules/weapons/weaponmodes/HsW01.h	(revision 5829)
+++ code/branches/core5/src/modules/weapons/weaponmodes/HsW01.h	(revision 5831)
@@ -57,5 +57,5 @@
             float speed_;
             float delay_;
-            Timer<HsW01> delayTimer_;
+            Timer delayTimer_;
     };
 }