Index: code/branches/tutorial/src/orxonox/worldentities/Drone.cc
===================================================================
--- code/branches/tutorial/src/orxonox/worldentities/Drone.cc	(revision 5793)
+++ code/branches/tutorial/src/orxonox/worldentities/Drone.cc	(revision 5833)
@@ -38,7 +38,11 @@
     CreateFactory(Drone);
 
+    /**
+    @brief
+        Constructor. Registers the object and initializes some default values.
+    */
     Drone::Drone(BaseObject* creator) : ControllableEntity(creator)
     {
-        //put your code in here:
+        // put your code in here:
         // - register the drone class to the core
         // - create a new controller and pass our this pointer to it as creator
@@ -58,4 +62,8 @@
     }
 
+    /**
+    @brief
+        Destructor. Destroys controller, if present.
+    */
     Drone::~Drone()
     {
@@ -64,4 +72,8 @@
     }
 
+    /**
+    @brief
+        Method for creating a Drone through XML.
+    */
     void Drone::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
@@ -74,4 +86,10 @@
     }
 
+    /**
+    @brief
+        Defines which actions the Drone has to take in each tick.
+    @param dt
+        The length of the tick.
+    */
     void Drone::tick(float dt)
     {
@@ -95,5 +113,10 @@
     }
     
-    
+    /**
+    @brief
+        Moves the Drone in the negative z-direction (Front/Back) by an amount specified by the first component of the input 2-dim vector.
+    @param value
+        The vector determining the amount of the movement.
+    */
     void Drone::moveFrontBack(const Vector2& value)
     {
@@ -102,4 +125,10 @@
     }
 
+    /**
+    @brief
+        Moves the Drone in the x-direction (Right/Left) by an amount specified by the first component of the input 2-dim vector.
+    @param value
+        The vector determining the amount of the movement.
+    */
     void Drone::moveRightLeft(const Vector2& value)
     {
@@ -108,4 +137,10 @@
     }
 
+    /**
+    @brief
+        Moves the Drone in the y-direction (Up/Down) by an amount specified by the first component of the input 2-dim vector.
+    @param value
+        The vector determining the amount of the movement.
+    */
     void Drone::moveUpDown(const Vector2& value)
     {
@@ -114,4 +149,10 @@
     }
 
+    /**
+    @brief
+        Rotates the Drone around the y-axis by the amount specified by the first component of the input 2-dim vector.
+    @param value
+        The vector determining the amount of the angular movement.
+    */
     void Drone::rotateYaw(const Vector2& value)
     {
@@ -119,4 +160,10 @@
     }
 
+    /**
+    @brief
+        Rotates the Drone around the x-axis by the amount specified by the first component of the input 2-dim vector.
+    @param value
+        The vector determining the amount of the angular movement.
+    */
     void Drone::rotatePitch(const Vector2& value)
     {
@@ -124,4 +171,10 @@
     }
 
+    /**
+    @brief
+        Rotates the Drone around the z-axis by the amount specified by the first component of the input 2-dim vector.
+    @param value
+        The vector determining the amount of the angular movement.
+    */
     void Drone::rotateRoll(const Vector2& value)
     {
Index: code/branches/tutorial/src/orxonox/worldentities/Drone.h
===================================================================
--- code/branches/tutorial/src/orxonox/worldentities/Drone.h	(revision 5793)
+++ code/branches/tutorial/src/orxonox/worldentities/Drone.h	(revision 5833)
@@ -36,4 +36,12 @@
 namespace orxonox
 {
+
+    /**
+    @brief
+        Drone, that is made to move upon a specified pattern.
+        This class was constructed for the PPS tutorial.
+    @author
+        Oli Scheuss
+    */
     class _OrxonoxExport Drone : public ControllableEntity
     {
@@ -42,6 +50,6 @@
             virtual ~Drone();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            virtual void tick(float dt);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a Drone through XML.
+            virtual void tick(float dt); //!< Defines which actions the Drone has to take in each tick.
 
             
@@ -54,16 +62,39 @@
             virtual void rotateRoll(const Vector2& value);
             
-            
+            /**
+            @brief Moves the Drone in the Front/Back-direction by the specifed amount.
+            @param value  The amount by which the drone is to be moved.
+            */
             inline void moveFrontBack(float value)
             { this->moveFrontBack(Vector2(value, 0)); }
+            /**
+            @brief Moves the Drone in the Right/Left-direction by the specifed amount.
+            @param value  The amount by which the drone is to be moved.
+            */
             inline void moveRightLeft(float value)
             { this->moveRightLeft(Vector2(value, 0)); }
+            /**
+            @brief Moves the Drone in the Up/Down-direction by the specifed amount.
+            @param value  The amount by which the drone is to be moved.
+            */
             inline void moveUpDown(float value)
             { this->moveUpDown(Vector2(value, 0)); }
             
+            /**
+            @brief Rotates the Drone around the y-axis by the specifed amount.
+            @param value  The amount by which the drone is to be rotated.
+            */
             inline void rotateYaw(float value)
             { this->rotateYaw(Vector2(value, 0)); }
+            /**
+            @brief Rotates the Drone around the x-axis by the specifed amount.
+            @param value  The amount by which the drone is to be rotated.
+            */
             inline void rotatePitch(float value)
             { this->rotatePitch(Vector2(value, 0)); }
+            /**
+            @brief Rotates the Drone around the z-axis by the specifed amount.
+            @param value  The amount by which the drone is to be rotated.
+            */
             inline void rotateRoll(float value)
             { this->rotateRoll(Vector2(value, 0)); }
@@ -78,9 +109,9 @@
             
         private:
-            DroneController *myController_;
+            DroneController *myController_; //!< The controller of the Drone.
             
             Vector3 steering_;
-            btVector3 localLinearAcceleration_;
-            btVector3 localAngularAcceleration_;
+            btVector3 localLinearAcceleration_; //!< The linear acceleration that is used to move the Drone the next tick.
+            btVector3 localAngularAcceleration_; //!< The linear angular acceleration that is used to move the Drone the next tick.
             float primaryThrust_;
             float auxilaryThrust_;