Index: /code/branches/tutorial/data/levels/tutorial.oxw
===================================================================
--- /code/branches/tutorial/data/levels/tutorial.oxw	(revision 5840)
+++ /code/branches/tutorial/data/levels/tutorial.oxw	(revision 5841)
@@ -13,14 +13,4 @@
    skybox       = "Orxonox/skypanoramagen1"
   >
-
-<Drone name="meineDrohne" position="0,0,-10" primarythrust="80" auxilarythrust="10" rotationthrust="10" mass= "50" linearDamping = "0.9" angularDamping = "0.7">
-  <attached>
-    <Model scale="10" mesh="drone.mesh"/>
-  </attached>
-  <collisionShapes>
-    <BoxCollisionShape position="0,0,0"      halfExtents="10, 10, 10" />
-  </collisionShapes>
-</Drone>
-
 
     <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
Index: /code/branches/tutorial/src/orxonox/controllers/DroneController.cc
===================================================================
--- /code/branches/tutorial/src/orxonox/controllers/DroneController.cc	(revision 5840)
+++ /code/branches/tutorial/src/orxonox/controllers/DroneController.cc	(revision 5841)
@@ -43,5 +43,4 @@
         // - make sure to register the object in the factory
         // - do any kind of initialisation
-        RegisterObject(DroneController);
         
         // this checks that our creator really is a drone
@@ -65,12 +64,10 @@
         // Place your code here:
         // - steering commands
-        static float totaltime = 0;
-        totaltime += dt;
         Drone *myDrone = static_cast<Drone*>(this->getControllableEntity());
-        if(totaltime<100)
-        {
-            myDrone->moveFrontBack( -sqrt(dt) );
-            myDrone->rotatePitch(-dt);
-        }
+        // you can use the following commands for steering 
+        // - moveFrontBack, moveRightLeft, moveUpDown 
+        // - rotatePitch, rotateYaw, rotateRoll 
+        // - apply the to myDrone (e.g. myDrone->rotateYaw(..) ) 
+
     }
 }
Index: /code/branches/tutorial/src/orxonox/worldentities/Drone.cc
===================================================================
--- /code/branches/tutorial/src/orxonox/worldentities/Drone.cc	(revision 5840)
+++ /code/branches/tutorial/src/orxonox/worldentities/Drone.cc	(revision 5841)
@@ -36,5 +36,4 @@
     // put your code in here:
     // create the factory for the drone
-    CreateFactory(Drone);
 
     /**
@@ -46,7 +45,5 @@
         // put your code in here:
         // - register the drone class to the core
-        // - create a new controller and pass our this pointer to it as creator
         this->myController_ = 0;
-        RegisterObject(Drone);
         
         this->localLinearAcceleration_.setValue(0, 0, 0);
@@ -58,5 +55,5 @@
         this->setCollisionType(WorldEntity::Dynamic);
         
-        myController_ = new DroneController(static_cast<BaseObject*>(this));
+        myController_ = new DroneController(static_cast<BaseObject*>(this)); //!< Creates a new controller and passes our this pointer to it as creator.
     }
 
@@ -80,7 +77,10 @@
         SUPER(Drone, XMLPort, xmlelement, mode);
 
-        XMLPortParam(Drone, "primaryThrust",  setPrimaryThrust, getPrimaryThrust,  xmlelement, mode);
-        XMLPortParam(Drone, "auxilaryThrust", setAuxilaryThrust, getAuxilaryThrust, xmlelement, mode);
-        XMLPortParam(Drone, "rotationThrust", setRotationThrust, getRotationThrust, xmlelement, mode);
+        // put your code in here:
+        // make sure you add the variables primaryThrust_, auxilaryThrust_ and rotationThrust_ to xmlport 
+        // make sure that the set- and get-functions exist.
+        // variables can be added by the following command 
+        // XMLPortParam(Classname, "xml-attribute-name (i.e. variablename)", setFunction, getFunction, xmlelement, mode)
+ 
     }
 
Index: /code/branches/tutorial/src/orxonox/worldentities/Drone.h
===================================================================
--- /code/branches/tutorial/src/orxonox/worldentities/Drone.h	(revision 5840)
+++ /code/branches/tutorial/src/orxonox/worldentities/Drone.h	(revision 5841)
@@ -105,9 +105,7 @@
             */
             inline void setPrimaryThrust( float thrust )
-                { this->primaryThrust_=thrust; }            
-            inline void setAuxilaryThrust( float thrust )
-                { this->auxilaryThrust_=thrust; }
-            inline void setRotationThrust( float thrust )
-                { this->rotationThrust_=thrust; }
+                { this->primaryThrust_=thrust; }      
+            // place your set-functions here.
+            // - hint: auxiliary thrust, rotation thrust.
             
             /**
@@ -117,8 +115,5 @@
             inline float getPrimaryThrust()
                 { return this->primaryThrust_; }
-            inline float getAuxilaryThrust()
-                { return this->auxilaryThrust_; }
-            inline float getRotationThrust()
-                { return this->rotationThrust_; }
+            // place your get-functions here.
             
         private: