Index: /branches/spaceshipcontrol/src/defs/class_id.h
===================================================================
--- /branches/spaceshipcontrol/src/defs/class_id.h	(revision 5843)
+++ /branches/spaceshipcontrol/src/defs/class_id.h	(revision 5844)
@@ -57,5 +57,5 @@
   // superclasses
   CL_MASK_SUPER_CLASS           =    0xff000000,
-  CL_BASE_OBJECT                =    0xff000000,
+  CL_BASE_OBJECT                =    0x00000000,
 
   CL_PARENT_NODE                =    0x01000000,
@@ -69,21 +69,29 @@
   CL_ELEMENT_2D                 =    0x10000000,
 
-  CL_SYNCHRONIZEABLE             =    0x20000000,
+  CL_SYNCHRONIZEABLE            =    0x20000000,
 
   CL_WORLD_ENTITY               =    0x40000000,
 
-
+  // subsuper-classes derivations taken : 1, 2, 5, a, b, c.     << THIS IS A LIST OF ALL THE DCL_MASK_SUBSUPERCLASS_ID's taken
   // subsuper-classes
   CL_MASK_SUBSUPER_CLASS        =    0x00fff000,
-  CL_MASK_SUBSUPER_CLASS_ID     =    0x00f00000,
-  CL_MASK_SUBSUPER_CLASS_ID2    =    0x000ff000,
-  CL_PLAYER                     =    0x00101000,
-  CL_NPC                        =    0x00102000,
-  CL_POWER_UP                   =    0x00104000,
-  CL_FIELD                      =    0x00108000,
-  CL_PROJECTILE                 =    0x00110000,
-  CL_WEAPON                     =    0x00120000,
-
-  // subsuper-classes derivations taken : 1, 5, a, b, c.     << THIS IS A LIST OF ALL THE DCL_MASK_SUBSUPERCLASS_ID's taken
+  CL_MASK_SUBSUPER_CLASS_IDA    =    0x00f00000,
+  CL_MASK_SUBSUPER_CLASS_IDB    =    0x000ff000,
+  // SUPER-PNodes
+  CL_FIELD                      =    0x00101000,
+  // SUPER-WorldEntities
+  CL_PLAYABLE                   =    0x00201000,
+  CL_PLAYER                     =    0x00202000,
+  CL_NPC                        =    0x00204000,
+  CL_PROJECTILE                 =    0x00208000,
+  CL_WEAPON                     =    0x00210000,
+  CL_POWER_UP                   =    0x00220000,
+
+  // SUPER-Modeling
+  CL_TEXTURE                    =    0x00c01000,
+  CL_MODEL                      =    0x00c02000,
+
+
+  // subsuper-classes derivations taken : 1, 2, 5, a, b, c.     << THIS IS A LIST OF ALL THE DCL_MASK_SUBSUPERCLASS_ID's taken
 
   // lowest level classes
@@ -118,5 +126,5 @@
   CL_GLGUI_MAIN_WIDGET          =    0x00000f41,
   CL_NETWORK_MANAGER            =    0x00000f50,
-  
+
 
 
@@ -178,9 +186,9 @@
 
   // graphical stuff (range from 0x00000800 to 0x000009ff)
-  CL_TEXTURE                    =    0x00c01000,
+  CL_FONT                       =    0x00c02802,
+
+
   CL_TEXT                       =    0x00b01801,
-  CL_FONT                       =    0x00c02802,
   CL_MATERIAL                   =    0x00000804,
-  CL_MODEL                      =    0x00000805, //!< @todo make this a SUBCLASS maybe
   CL_OBJMODEL                   =    0x00000806,
   CL_PROMITIVE_MODEL            =    0x00000807,
Index: /branches/spaceshipcontrol/src/lib/lang/base_object.cc
===================================================================
--- /branches/spaceshipcontrol/src/lib/lang/base_object.cc	(revision 5843)
+++ /branches/spaceshipcontrol/src/lib/lang/base_object.cc	(revision 5844)
@@ -112,6 +112,6 @@
   else if (classID & CL_MASK_SUBSUPER_CLASS)
   {
-    if (likely(((this->classID & CL_MASK_SUBSUPER_CLASS_ID) == (this->classID & CL_MASK_SUBSUPER_CLASS_ID)) &&
-        this->classID & classID & CL_MASK_SUBSUPER_CLASS_ID2))
+    if (likely(((this->classID & CL_MASK_SUBSUPER_CLASS_IDA) == (this->classID & CL_MASK_SUBSUPER_CLASS_IDA)) &&
+        this->classID & classID & CL_MASK_SUBSUPER_CLASS_IDB))
       return true;
   }
Index: /branches/spaceshipcontrol/src/lib/sound/sound_engine.cc
===================================================================
--- /branches/spaceshipcontrol/src/lib/sound/sound_engine.cc	(revision 5843)
+++ /branches/spaceshipcontrol/src/lib/sound/sound_engine.cc	(revision 5844)
@@ -281,5 +281,5 @@
 
   // INITIALIZING THE DEVICE:
-  ALchar deviceName[] =
+  ALubyte deviceName[] =
 #ifdef __WIN32__
       "native";